# ATS-N metadata mapping
metadata_ats_dict = {
    'filerInfo_filer_filerCredentials_ccc': 'filerCcc',
    'filerInfo_filer_filerCredentials_cik': 'filerCik',
    'filerInfo_flags_confirmingCopyFlag': 'confirmingCopyFlag',
    'filerInfo_flags_overrideInternetFlag': 'overrideInternetFlag',
    'filerInfo_liveTestFlag': 'liveTestFlag',
    'submissionType': 'submissionType'
}

cover_ats_dict = {
    'rbOperatesPursuantToFormATS' : 'operatesPursuantToFormATS',
    'txNMSStockATSName' : 'atsName'
}

part_one_ats_dict = {
    'atsNames_atsName_@txPart1Item3ATSName': 'formalATSName',   
    'cbPart1Item8Exhibit1atWebsite': 'exhibit1AtWebsite',
    'cbPart1Item9Exhibit2atWebsite': 'exhibit2AtWebsite',
    'part1Item5bEffectiveMembershipDate': 'membershipEffectiveDate',
    'part1Item7PrimarySite_city': 'primarySiteCity',
    'part1Item7PrimarySite_state': 'primarySiteState',
    'part1Item7PrimarySite_street1': 'primarySiteStreet1',
    'part1Item7PrimarySite_street2': 'primarySiteStreet2',
    'part1Item7PrimarySite_zip': 'primarySiteZip',
    'part1Item7SecondarySiteRecords_secondarySiteI7_city': 'secondarySiteCity',
    'part1Item7SecondarySiteRecords_secondarySiteI7_state': 'secondarySiteState',
    'part1Item7SecondarySiteRecords_secondarySiteI7_street1': 'secondarySiteStreet1',
    'part1Item7SecondarySiteRecords_secondarySiteI7_street2': 'secondarySiteStreet2',
    'part1Item7SecondarySiteRecords_secondarySiteI7_zip': 'secondarySiteZip',
    'rbPart1Item1IsBd': 'isBrokerDealer',
    'txPart1Item2ATSName': 'marketName',
    'txPart1Item4aBdCrdNumber': 'brokerDealerCrdNumber',
    'txPart1Item4aBdFileNumber': 'brokerDealerFileNumber',
    'txPart1Item5aNsaFullName': 'nsaFullName',
    'txtPart1Item5cNmsStockMPID': 'stockMPID',
    'txtPart1Item6uwebsite': 'website'
}

part_two_ats_dict = {
    'affiliatesPermittedToEnterInterest_@rbPart2Item2aAreAfflPermittedToEnterInterest': 'affiliatesPermittedToEnterInterest',
    'affiliatesPermittedToEnterInterest_part2Item2bAreSevicestoAfflSametoSubscribers_@rbPart2Item2bAreSevicestoAfflSametoSubscribers': 'areServicesToAffiliatesSameAsSubscribers',
    'affiliatesPermittedToEnterInterest_part2Item2bAreSevicestoAfflSametoSubscribers_taPart2Item2bExplainDiff': 'differenceInAffiliateServicesExplanation',
    'affiliatesPermittedToEnterInterest_rbPart2Item2bAreSevicestoAfflSametoSubscribers': 'servicesEqualForAffiliatesAndSubscribers',
    'affiliatesPermittedToEnterInterest_rbPart2Item2cAreThereArrangementsWithAffl': 'arrangementsWithAffiliatesExist',
    'affiliatesPermittedToEnterInterest_taPart2Item2aAfflThatEnterInterest': 'affiliatesThatEnterInterest',
    'part2Item1aArePermittedToEnterInterest_@rbPart2Item1aArePermittedToEnterInterest': 'brokerDealerPermittedToEnterInterest',
    'part2Item1aArePermittedToEnterInterest_part2Item1bAreSevicesSametoAllSubscribers_@rbPart2Item1bAreSevicesSametoAllSubscribers': 'areServicesSameToAllSubscribers',
    'part2Item1aArePermittedToEnterInterest_part2Item1bAreSevicesSametoAllSubscribers_taPart2Item2bExplainDiff': 'differenceInSubscriberServicesExplanation',
    'part2Item1aArePermittedToEnterInterest_rbPart2Item1bAreSevicesSametoAllSubscribers': 'servicesEqualForAllSubscribers',
    'part2Item1aArePermittedToEnterInterest_rbPart2Item1cAreThereArrangements': 'brokerDealerArrangementsExist',
    'part2Item1aArePermittedToEnterInterest_taPart2Item1aUnitNamesEnterInterest': 'unitNamesThatEnterInterest',
    'part2Item3aCanSubscrOptOutWithOATIOfAffl_@rbPart2Item3aCanSubscrOptOutWithOATIOfAffl': 'canOptOutOfAffiliateOrderInteraction',
    'part2Item3aCanSubscrOptOutWithOATIOfAffl_taPart2Item3bExplianOptOut': 'affiliateOptOutExplanation',
    'part2Item3aCanSubscrOptOutWithOATIOfBD_@rbPart2Item3aCanSubscrOptOutWithOATIOfBD': 'canOptOutOfBrokerDealerOrderInteraction',
    'part2Item3aCanSubscrOptOutWithOATIOfBD_taPart2Item3aExplianOptOut': 'brokerDealerOptOutExplanation',
    'part2Item4aAreThereArrangementsBtwBDAndTC_@rbPart2Item4aAreThereArrangementsBtwBDAndTC': 'arrangementsExistBetweenBrokerDealerAndTradingCenter',
    'part2Item4aAreThereArrangementsBtwBDAndTC_rbPart2Item4bAreThereArrangementsBtwAfflAndTC': 'arrangementsExistBetweenAffiliateAndTradingCenter',
    'part2Item4aAreThereArrangementsBtwBDAndTC_taPart2Item4aTDAndATSServices': 'tradingCenterAndATSServicesDescription',
    'part2Item5aDoesOfferProductsAndServices_@rbPart2Item5aDoesOfferProductsAndServices': 'offersProductsAndServices',
    'part2Item5aDoesOfferProductsAndServices_part2Item5bAreSevicesSametoAllSubscribersAndBD_@rbPart2Item5bAreSevicesSametoAllSubscribersAndBD': 'areServicesSameToAllSubscribersAndBrokerDealer',
    'part2Item5aDoesOfferProductsAndServices_part2Item5bAreSevicesSametoAllSubscribersAndBD_taPart2Item5bExplainDiff': 'differenceInServicesExplanation',
    'part2Item5aDoesOfferProductsAndServices_rbPart2Item5bAreSevicesSametoAllSubscribersAndBD': 'servicesEqualForAllSubscribersAndBrokerDealer',
    'part2Item5aDoesOfferProductsAndServices_taPart2Item5aProductsAndServices': 'productsAndServicesDescription',
    'part2Item5cDoesAfflOfferProductsAndServices_@rbPart2Item5cDoesAfflOfferProductsAndServices': 'affiliateOffersProductsAndServices',
    'part2Item5cDoesAfflOfferProductsAndServices_rbPart2Item5dAreTCOfSevicesSametoAll': 'affiliateServicesEqualForAll',
    'part2Item5cDoesAfflOfferProductsAndServices_taPart2Item5cAfflProvidedProductsAndServices': 'affiliateProvidedProductsAndServicesDescription',
    'part2Item6aDoesEmployeeAccessConfidentialInfo_@rbPart2Item6aDoesEmployeeAccessConfidentialInfo': 'employeeAccessToConfidentialInfo',
    'part2Item6aDoesEmployeeAccessConfidentialInfo_taPart2Item6aUnitAfflEmployeeServices': 'unitAffiliateEmployeeServicesDescription',
    'part2Item6bDoesAnyEntitySupportServices_@rbPart2Item6bDoesAnyEntitySupportServices': 'entitySupportServicesExist',
    'part2Item6bDoesAnyEntitySupportServices_part2Item6cDoesServiceProviderUseATSServices_@rbPart2Item6cDoesServiceProviderUseATSServices': 'serviceProviderUsesATSServices',
    'part2Item6bDoesAnyEntitySupportServices_part2Item6cDoesServiceProviderUseATSServices_rbPart2Item6dAreATSSevicesSametoAll': 'atsServicesEqualForAll',
    'part2Item6bDoesAnyEntitySupportServices_part2Item6cDoesServiceProviderUseATSServices_taPart2Item6cProviderAfflAndServicesUsed': 'providerAffiliateAndServicesUsedDescription',
    'part2Item6bDoesAnyEntitySupportServices_rbPart2Item6cDoesServiceProviderUseATSServices': 'serviceProviderUsesATSServices',
    'part2Item6bDoesAnyEntitySupportServices_taPart2Item6bServiceProvider': 'serviceProviderDescription',
    'part2Item7bCanSubscriberConsentToDisclosure_@rbPart2Item7bCanSubscriberConsentToDisclosure': 'subscriberCanConsentToDisclosure',
    'part2Item7bCanSubscriberConsentToDisclosure_part2Item7cCanSubscriberWithdrawConsent_@rbPart2Item7cCanSubscriberWithdrawConsent': 'subscriberCanWithdrawConsent',
    'part2Item7bCanSubscriberConsentToDisclosure_part2Item7cCanSubscriberWithdrawConsent_taPart2Item7cExplainHowAndConditions': 'withdrawConsentExplanation',
    'part2Item7bCanSubscriberConsentToDisclosure_taPart2Item7bExplainHowAndConditions': 'consentToDisclosureExplanation',
    'rbPart2Item1aArePermittedToEnterInterest': 'permittedToEnterInterest',
    'rbPart2Item1dCanOATInterestBeRouted': 'orderInterestCanBeRouted',
    'rbPart2Item2aAreAfflPermittedToEnterInterest': 'affiliatesPermittedToEnterInterest',
    'rbPart2Item2dCanOATIBeRoutedByAffl': 'orderInterestCanBeRoutedByAffiliate',
    'rbPart2Item3aCanSubscrOptOutWithOATIOfAffl': 'subscriberCanOptOutOfAffiliateInteraction',
    'rbPart2Item3aCanSubscrOptOutWithOATIOfBD': 'subscriberCanOptOutOfBrokerDealerInteraction',
    'rbPart2Item3cAreOptOutSametoAllSubscribers': 'optOutOptionsEqualForAllSubscribers',
    'rbPart2Item4aAreThereArrangementsBtwBDAndTC': 'arrangementsBetweenBrokerDealerAndTradingCenterExist',
    'rbPart2Item5aDoesOfferProductsAndServices': 'offersProductsAndServices',
    'rbPart2Item5cDoesAfflOfferProductsAndServices': 'affiliateOffersProductsAndServices',
    'rbPart2Item7bCanSubscriberConsentToDisclosure': 'subscriberCanConsentToDisclosure',
    'taPart2Item7aDescrOfSafeGaurdsAndProcedures': 'safeguardsAndProceduresDescription',
    'taPart2Item7dSummaryOfRolesRespOfPersons': 'rolesAndResponsibilitiesSummary'
}

part_three_ats_dict = {
    'part3Item10eDiffDtls_@rbPart3Item10eIsAnyDifBtwnPreOpExecFlwngStpg': 'differencesBetweenPreOpExecution',
    'part3Item10eDiffDtls_taPart3Item10eDiffDtls': 'preOperationExecutionDifferences',
    'part3Item11dDiffDtls_@rbPart3Item11dIsProcsRulsSameForAll': 'processingRulesSameForAll',
    'part3Item11dDiffDtls_taPart3Item11dDiffDtls': 'processingRulesDifferences',
    'part3Item13aSegmntDtls_@rbPart3Item13aIsOrdrTiSegmntd': 'orderTradingInterestSegmented',
    'part3Item13aSegmntDtls_part3Item13bSegmntDtls_@rbPart3Item13bIsSegmntatnSameForAll': 'segmentationSameForAll',
    'part3Item13aSegmntDtls_part3Item13bSegmntDtls_taPart3Item13bSegDiffDtls': 'segmentationDifferences',
    'part3Item13aSegmntDtls_part3Item13dDsclrContntDtls_@rbPart3Item13dIsSegCatgDisclosd': 'segmentCategoryDisclosed',
    'part3Item13aSegmntDtls_part3Item13dDsclrContntDtls_rbPart3Item13eIsDsclosrSameForAll': 'disclosureSameForAll',
    'part3Item13aSegmntDtls_part3Item13dDsclrContntDtls_taPart3Item13dDsclosrContntDtls': 'disclosureContentDetails',
    'part3Item13aSegmntDtls_rbPart3Item13bIsSegmntatnSameForAll': 'segmentationSameForAll',
    'part3Item13aSegmntDtls_taPart3Item13aSegProcdurDtls': 'segmentationProcedureDetails',
    'part3Item14aCntrPrtySelectnDtls_@rbPart3Item14aIsDsgToIntrctOrNot': 'designatedToInteract',
    'part3Item14aCntrPrtySelectnDtls_rbPart3Item14bIsSelectnSameForAll': 'counterpartySelectionSameForAll',
    'part3Item14aCntrPrtySelectnDtls_taPart3Item14aCntrPrtyDtls': 'counterpartyDetails',
    'part3Item15bSubSctbDtls_@rbPart3Item15bIsSubScrbOrdBnd': 'subscriberOrderBound',
    'part3Item15bSubSctbDtls_rbPart3Item15cIsDsplyProcSameForAll': 'displayProcedureSameForAll',
    'part3Item15bSubSctbDtls_taPart3Item15bSubscrBndDtls': 'subscriberBindingDetails',
    'part3Item16aAffirInstrDtls_@rbPart3Item16aIsInstRoutd': 'instructionRouted',
    'part3Item16aAffirInstrDtls_part3Item16bAffirmInstrDtls_@rbPart3Item16bIsRoutdBefrInstr': 'routedBeforeInstruction',
    'part3Item16aAffirInstrDtls_part3Item16bAffirmInstrDtls_taPart3Item16bAffirmInstrDiffDtls': 'affirmInstructionDifferences',
    'part3Item17aAffirInstrDtls_@rbPart3Item17aIsDiffBtwnOrdTITrtmnt': 'differencesBetweenOrderTrading',
    'part3Item17aAffirInstrDtls_taPart3Item17aTrtmntDiffDtls': 'treatmentDifferences',
    'part3Item18aTrdingHrDtls_@rbPart3Item18aIsOutsdeTrdingHrs': 'outsideTradingHours',
    'part3Item18aTrdingHrDtls_part3Item18bOutsdHrsDiffDtls_@rbPart3Item18bIsAnyDiffInTrdingOutSdHrs': 'differenceInOutsideHoursTrading',
    'part3Item18aTrdingHrDtls_part3Item18bOutsdHrsDiffDtls_taPart3Item18bDiffDtls': 'outsideHoursDifferences',
    'part3Item18aTrdingHrDtls_rbPart3Item18cIsTrtedDiffOutsdHrs': 'treatedDifferentlyOutsideHours',
    'part3Item26PlatFrmData_@rbPart3Item26IsOrdrFloExecStatsPublshd': 'orderFlowExecutionStatsPublished',
    'part3Item26PlatFrmData_cbPart3Item26iInfoRqstdUndrExbt4AvlblAtWebst': 'exhibit4InfoAvailableAtWebsite',
    'part3Item26PlatFrmData_cbPart3Item26iiInfoRqstdUndrExbt5AvlblAtWebst': 'exhibit5InfoAvailableAtWebsite',
    'part3Item2bSummaryOfConditions_@rbPart3Item2bIsThereOtherConditions': 'otherConditionsExist',
    'part3Item2bSummaryOfConditions_rbPart3Item2cIsConditionsSameForAll': 'conditionsSameForAll',
    'part3Item2bSummaryOfConditions_taPart3Item2bSummaryOfCndtns': 'summaryOfConditions',
    'part3Item3aSumryOfExcludngCondtns_@rbPart3Item3aIsExcludeSubscriber': 'excludeSubscriber',
    'part3Item3aSumryOfExcludngCondtns_part3Item3bSummaryOfConditions_@rbPart3Item3bIsCondtnsSameForAll': 'excludedConditionsSameForAll',
    'part3Item3aSumryOfExcludngCondtns_part3Item3bSummaryOfConditions_taPart3Item3bSummaryOfDifferences': 'excludingConditionsDifferences',
    'part3Item3aSumryOfExcludngCondtns_rbPart3Item3bIsCondtnsSameForAll': 'excludingConditionsSameForAll',
    'part3Item3aSumryOfExcludngCondtns_taPart3Item3aExcludngSumryDtls': 'excludingSummaryDetails',
    'part3Item5aProtocolDetails_@rbPart3Item5aIsPermitOrdrTradng': 'permitOrderTrading',
    'part3Item5aProtocolDetails_rbPart3Item5bIsProtclsameForAll': 'protocolSameForAll',
    'part3Item5aProtocolDetails_taPart3Item5aProtocolused': 'protocolUsed',
    'part3Item5cOthrDtls_@rbPart3Item5cIsAnyOtherMeans': 'anyOtherMeans',
    'part3Item5cOthrDtls_rbPart3Item5dIsTnCSameForAll': 'termsAndConditionsSameForAll',
    'part3Item5cOthrDtls_taPart3Item5cOthrMeansDtls': 'otherMeansDetails',
    'part3Item6aProtocolDetails_@rbPart3Item6aIsCoLocRltdSrvcsOfrd': 'coLocationRelatedServicesOffered',
    'part3Item6aProtocolDetails_rbPart3Item6bIsTNCsameForAll': 'termsAndConditionsSameForCoLocation',
    'part3Item6aProtocolDetails_taPart3Item6aCoLocRltdSrvcsDtls': 'coLocationRelatedServicesDetails',
    'part3Item8aSizeReqrmnts_@rbPart3Item8aIsMinOrMaxSizeReqd': 'minOrMaxSizeRequired',
    'part3Item8aSizeReqrmnts_part3Item8bReqProcDetails_@rbPart3Item8bIsReqProcSameForAll': 'requirementProcedureSameForAll',
    'part3Item8aSizeReqrmnts_part3Item8bReqProcDetails_taPart3Item8bDiffrncsInOtiReqrmnts': 'differencesInOrderRequirements',
    'part3Item8aSizeReqrmnts_rbPart3Item8bIsReqProcSameForAll': 'requirementProcedureSameForAll',
    'part3Item8aSizeReqrmnts_taPart3Item8aOtiSizeReqrmns': 'orderSizeRequirements',
    'part3Item8cOddltOrdrReqs_@rbPart3Item8cIsOddLotsAcptdExecutd': 'oddLotsAcceptedExecuted',
    'part3Item8cOddltOrdrReqs_rbPart3Item8dIsReqsProcdurSameForAll': 'requirementsProcedureSameForAll',
    'part3Item8cOddltOrdrReqs_taPart3Item8cOddLtOrdrReqsnProcdurs': 'oddLotOrderRequirementsAndProcedures',
    'part3Item8eMixltOrdrDetails_@rbPart3Item8eIsMixLotOrdrsAcptdExecutd': 'mixedLotOrdersAcceptedExecuted',
    'part3Item8eMixltOrdrDetails_rbPart3Item8fIsRecProcSameForAll': 'receivingProcedureSameForAll',
    'part3Item8eMixltOrdrDetails_taPart3Item8eMixltOrdrReqsProcDtls': 'mixedLotOrderRequirementsDetails',
    'part3Item9aMsgDtls_@rbPart3Item9aIsAnyMsgToIndicTI': 'anyMessageIndicatingTrading',
    'part3Item9aMsgDtls_taPart3Item9aMsgUsgDtls': 'messageUsageDetails',
    'rbPart3Item10bIsOpnReopnSameForAll': 'openReopenSameForAll',
    'rbPart3Item10dIsAnyDifBtwnExeProcTrdHrs': 'differencesBetweenExecutionProcedureTradingHours',
    'rbPart3Item10eIsAnyDifBtwnPreOpExecFlwngStpg': 'differencesBetweenPreOpExecutionFollowingStopping',
    'rbPart3Item11bIsMeansFeciltsSameForAll': 'meansFacilitiesSameForAll',
    'rbPart3Item11dIsProcsRulsSameForAll': 'processingRulesSameForAll',
    'rbPart3Item12aIsAnyFrmlInfrmlArngmnts': 'anyFormalInformalArrangements',
    'rbPart3Item13aIsOrdrTiSegmntd': 'orderTradingInterestSegmented',
    'rbPart3Item13cIsCustmrOrdr': 'customerOrder',
    'rbPart3Item15aIsElectrncCommu': 'electronicCommunication',
    'rbPart3Item15bIsSubScrbOrdBnd': 'subscriberOrderBound',
    'rbPart3Item16aIsInstRoutd': 'instructionRouted',
    'rbPart3Item17aIsDiffBtwnOrdTITrtmnt': 'differencesBetweenOrderTradingTreatment',
    'rbPart3Item17bIsTrtmntSameForAll': 'treatmentSameForAll',
    'rbPart3Item18aIsOutsdeTrdingHrs': 'outsideTradingHours',
    'rbPart3Item20bIsSuspndProcdurSameFrAll': 'suspendProcedureSameForAll',
    'rbPart3Item21bIsMtrlArngmtSameFrAll': 'materialArrangementSameForAll',
    'rbPart3Item22bIsMtrlArngmtSameFrAll': 'materialArrangementSameForAll',
    'rbPart3Item23bIsSrcSameFrAll': 'sourceSameForAll',
    'rbPart3Item24aIsSubScrbrOrdr': 'subscriberOrder',
    'rbPart3Item25aIsAvgDlyTradinVolExcd': 'averageDailyTradingVolumeExceeded',
    'rbPart3Item26IsOrdrFloExecStatsPublshd': 'orderFlowExecutionStatsPublished',
    'rbPart3Item2aRegisteredBD': 'registeredBrokerDealer',
    'rbPart3Item2dIsThereWrittenAgreement': 'writtenAgreementExists',
    'rbPart3Item4bIsHrsOfOperationsame': 'hoursOfOperationSame',
    'rbPart3Item5aIsPermitOrdrTradng': 'permitOrderTrading',
    'rbPart3Item5cIsAnyOtherMeans': 'anyOtherMeans',
    'rbPart3Item6aIsCoLocRltdSrvcsOfrd': 'coLocationRelatedServicesOffered',
    'rbPart3Item6cIsAnyOtherMeans': 'anyOtherMeansForCoLocation',
    'rbPart3Item6eIsAnyRducdSpOfCom': 'anyReducedSpeedOfCommunication',
    'rbPart3Item7bIsTnCSameForAll': 'termsAndConditionsSameForAll',
    'rbPart3Item8aIsMinOrMaxSizeReqd': 'minOrMaxSizeRequired',
    'rbPart3Item8cIsOddLotsAcptdExecutd': 'oddLotsAcceptedExecuted',
    'rbPart3Item9aIsAnyMsgToIndicTI': 'anyMessageIndicatingTrading',
    'rbPart3Item9bIsIndIntrstSameForAll': 'indicationInterestSameForAll',
    'taPart3Item10aOpenReOpenDtls': 'openReopenDetails',
    'taPart3Item10cUnexeOrdrTIDtls': 'unexecutedOrderTradingDetails',
    'taPart3Item11aStrucOfNmsStk': 'structureOfNmsStock',
    'taPart3Item11cRulsProcsOfNmsStk': 'rulesAndProceduresOfNmsStock',
    'taPart3Item19aSrvcUsgFees': 'serviceUsageFees',
    'taPart3Item19bBundldSrvcUsgFees': 'bundledServiceUsageFees',
    'taPart3Item19cRbtDiscOfFees': 'rebateDiscountOfFees',
    'taPart3Item1OtherSubscrbrDtls': 'otherSubscriberDetails',
    'taPart3Item1SubscriberType': 'subscriberType',
    'taPart3Item20aSuspndProcdur': 'suspendProcedure',
    'taPart3Item21aMtrlArngmntDtls': 'materialArrangementDetails',
    'taPart3Item22aMtrlArngmntDtls': 'materialArrangementDetails',
    'taPart3Item23aMrktDatSrc': 'marketDataSource',
    'taPart3Item4aHrsOfOperation': 'hoursOfOperation',
    'taPart3Item7AOrdrTypExplain': 'orderTypeExplanation'
}

# Not implemented yet, not sure a 4 exists in ATS-N yet
part_four_ats_dict = {}